#ifndef INC_EX_h
#define INC_EX_h
/*	@(#)EX.h	1.2 2/23/93
 *	Author:	Roger A. Cole
 *	Date:	02-08-91
 *
 *	Experimental Physics and Industrial Control System (EPICS)
 *
 *	Copyright 1991-93, the Regents of the University of California,
 *	and the University of Chicago Board of Governors.
 *
 *	This software was produced under  U.S. Government contracts:
 *	(W-7405-ENG-36) at the Los Alamos National Laboratory,
 *	and (W-31-109-ENG-38) at Argonne National Laboratory.
 *
 *	Initial development by:
 *		The Controls and Automation Group (AT-8)
 *		Ground Test Accelerator
 *		Accelerator Technology Division
 *		Los Alamos National Laboratory
 *
 *	Co-developed with
 *		The Controls and Computing Group
 *		Accelerator Systems Division
 *		Advanced Photon Source
 *		Argonne National Laboratory
 *
 * Modification Log:
 * -----------------
 *  .00 02-08-91 rac	initial version
 *  .01 04-07-92 rac	cloned from ARR.h; added a status line
 *  .02 01-25-93 rac	added a useMeans flag
 * EX.h,v
 * Revision 1.2  1994/05/06 19:05:46  mrk
 * conversion from sccs to cvs
 *
 *
 */
/*+/mod***********************************************************************
* TITLE	EX.h - definitions for EX, the exporting software
*
* DESCRIPTION
*
*-***************************************************************************/

typedef enum {
    EX_NULL,	/* no exporting */
    EX_DO,	/* export to file */
} EX_TYPE;


typedef struct exCtx {
    GUI_CTX	*pGuiCtx;	/* pointer to gui context */
    Panel_item	message_PM;	/* PANEL_MESSAGE item for status message */
    Panel_item	dir_PT;		/* PANEL_TEXT item for directory */
    char	dir[GUI_TDIM];	/* directory */
    Panel_item	file_PT;	/* PANEL_TEXT item for file name */
    char	file[GUI_TDIM];	/* file name */
    Panel_item	fileMode_PCS;	/* PANEL_CHOICE_STACK item for file mode */
    Frame	EXwin_CF;	/* command frame for exporting */
    Panel_item	EXtype_PCS;	/* export type */
    Panel_item	EXstat_PCS;	/* value status--suppress or show */
    char	SSFtitle[GUI_TDIM];/* title for sample set files */
    SYD_SPEC	**ppSspec;	/* pointer to pointer to sample set spec */
    short	useStats;	/* 1 if to export mean,stdDev */
    short	useMeans;	/* 1 if to export mean */
} EX_CTX;


void EXinitButton(), EXinitMenu(), EXquit();

#endif	/* INC_EX_h */
