#ifndef INC_PR_h
#define INC_PR_h
/*	@(#)PR.h	1.2 2/23/93
 *	Author:	Roger A. Cole
 *	Date:	02-08-91
 *
 *	Experimental Physics and Industrial Control System (EPICS)
 *
 *	Copyright 1991-93, the Regents of the University of California,
 *	and the University of Chicago Board of Governors.
 *
 *	This software was produced under  U.S. Government contracts:
 *	(W-7405-ENG-36) at the Los Alamos National Laboratory,
 *	and (W-31-109-ENG-38) at Argonne National Laboratory.
 *
 *	Initial development by:
 *		The Controls and Automation Group (AT-8)
 *		Ground Test Accelerator
 *		Accelerator Technology Division
 *		Los Alamos National Laboratory
 *
 *	Co-developed with
 *		The Controls and Computing Group
 *		Accelerator Systems Division
 *		Advanced Photon Source
 *		Argonne National Laboratory
 *
 * Modification Log:
 * -----------------
 *  .00 02-08-91 rac	initial version
 *  .01 04-07-92 rac	cloned from ARR.h
 *  .02 01-25-93 rac	added a useMeans flag
 * PR.h,v
 * Revision 1.2  1994/05/06 19:05:57  mrk
 * conversion from sccs to cvs
 *
 *
 */
/*+/mod***********************************************************************
* TITLE	PR.h - definitions for PR, the printing software
*
* DESCRIPTION
*
*-***************************************************************************/

typedef enum {
    PR_NULL,	/* no output */
    PR_PLAIN,	/* ordinary print to the screen */
    PR_DO,	/* output to file */
    PR_HC,	/* print to printer */
} PR_TYPE;


typedef struct prCtx {
    GUI_CTX	*pGuiCtx;	/* pointer to gui context */
    GUI_PRT	*pGuiPrt;	/* pointer to gui printer context */
    int		colCount;	/* number of columns in printout */
    Panel_item	colCount_PT;	/* PANEL_TEXT item for number of columns */
    int		colWidth;	/* width of a column */
    Panel_item	colWidth_PT;	/* PANEL_TEXT item for column width */
    Panel_item	dir_PT;		/* PANEL_TEXT item for directory */
    char	dir[GUI_TDIM];	/* directory */
    Panel_item	file_PT;	/* PANEL_TEXT item for file name */
    char	file[GUI_TDIM];	/* file name */
    Panel_item	fileMode_PCS;	/* PANEL_CHOICE_STACK item for file mode */
    char	HCfName[GUI_TDIM];/* name for temp file for printing */
    int		point;		/* point size */
    Frame	PRwin_CF;	/* command frame */
    char	PRwinName[GUI_TDIM];/* temp file for "backing" the textsw */
    Textsw	PRwinTextsw;	/* text subwindow to display print output */
    SYD_SPEC	**ppSspec;	/* pointer to pointer to sample set spec */
    short	useStats;	/* 1 if to print mean,stdDev */
    short	useMeans;	/* 1 if to print mean */
} PR_CTX;


void PRinitButton(), PRinitMenu(), PRquit();

#endif	/* INC_PR_h */
