/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
#ifndef INC_EX_h
#define INC_EX_h
/*	@(#)EX.h	1.2 2/23/93
 *	Author:	Roger A. Cole
 *	Date:	02-08-91
 *
 *	Experimental Physics and Industrial Control System (EPICS)
 *
 */
/*+/mod***********************************************************************
* TITLE	EX.h - definitions for EX, the exporting software
*
* DESCRIPTION
*
*-***************************************************************************/

typedef enum {
    EX_NULL,	/* no exporting */
    EX_DO,	/* export to file */
} EX_TYPE;


typedef struct exCtx {
    GUI_CTX	*pGuiCtx;	/* pointer to gui context */
    Panel_item	message_PM;	/* PANEL_MESSAGE item for status message */
    Panel_item	dir_PT;		/* PANEL_TEXT item for directory */
    char	dir[GUI_TDIM];	/* directory */
    Panel_item	file_PT;	/* PANEL_TEXT item for file name */
    char	file[GUI_TDIM];	/* file name */
    Panel_item	fileMode_PCS;	/* PANEL_CHOICE_STACK item for file mode */
    Frame	EXwin_CF;	/* command frame for exporting */
    Panel_item	EXtype_PCS;	/* export type */
    Panel_item	EXstat_PCS;	/* value status--suppress or show */
    char	SSFtitle[GUI_TDIM];/* title for sample set files */
    SYD_SPEC	**ppSspec;	/* pointer to pointer to sample set spec */
    short	useStats;	/* 1 if to export mean,stdDev */
    short	useMeans;	/* 1 if to export mean */
} EX_CTX;


void EXinitButton(), EXinitMenu(), EXquit();

#endif	/* INC_EX_h */
