/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
#ifndef INC_PR_h
#define INC_PR_h
/*	@(#)PR.h	1.2 2/23/93
 *	Author:	Roger A. Cole
 *	Date:	02-08-91
 *
 *	Experimental Physics and Industrial Control System (EPICS)
 *
 */
/*+/mod***********************************************************************
* TITLE	PR.h - definitions for PR, the printing software
*
* DESCRIPTION
*
*-***************************************************************************/

typedef enum {
    PR_NULL,	/* no output */
    PR_PLAIN,	/* ordinary print to the screen */
    PR_DO,	/* output to file */
    PR_HC,	/* print to printer */
} PR_TYPE;


typedef struct prCtx {
    GUI_CTX	*pGuiCtx;	/* pointer to gui context */
    GUI_PRT	*pGuiPrt;	/* pointer to gui printer context */
    int		colCount;	/* number of columns in printout */
    Panel_item	colCount_PT;	/* PANEL_TEXT item for number of columns */
    int		colWidth;	/* width of a column */
    Panel_item	colWidth_PT;	/* PANEL_TEXT item for column width */
    Panel_item	dir_PT;		/* PANEL_TEXT item for directory */
    char	dir[GUI_TDIM];	/* directory */
    Panel_item	file_PT;	/* PANEL_TEXT item for file name */
    char	file[GUI_TDIM];	/* file name */
    Panel_item	fileMode_PCS;	/* PANEL_CHOICE_STACK item for file mode */
    char	HCfName[GUI_TDIM];/* name for temp file for printing */
    int		point;		/* point size */
    Frame	PRwin_CF;	/* command frame */
    char	PRwinName[GUI_TDIM];/* temp file for "backing" the textsw */
    Textsw	PRwinTextsw;	/* text subwindow to display print output */
    SYD_SPEC	**ppSspec;	/* pointer to pointer to sample set spec */
    short	useStats;	/* 1 if to print mean,stdDev */
    short	useMeans;	/* 1 if to print mean */
} PR_CTX;


void PRinitButton(), PRinitMenu(), PRquit();

#endif	/* INC_PR_h */
