/****************************************************************************
			GTA PROJECT   AT division

	Copyright, 1990, The Regents of the University of California
		      Los Alamos National Laboratory

	FILE PATH:	~ar/arCFChanTest.c
	ENVIRONMENT:	SunOS, VxWorks
	MAKE OPTIONS:
	SCCS VERSION:	@(#)arCFChanTest.c	1.1
*+/mod***********************************************************************
* TITLE	arCFChanTest - test storing data by channel streams
*
* DESCRIPTION
*
*-
* Modification History
* version   date    programmer   comments
* ------- -------- ------------ -----------------------------------
* 1.1     07/20/90 R. Cole      initial version
* arCFChanTest.c,v
* Revision 1.2  1994/05/06 19:05:59  mrk
* conversion from sccs to cvs
*
*
*****************************************************************************/

#ifdef vxWorks
#   include <vxWorks.h>
#   include <stdioLib.h>
#   include <ioLib.h>
#else
#   include <stdio.h>
#   include <sys/file.h>
#endif

#include <genDefs.h>
#include <arAccessLib.h>
#include <tsDefs.h>
#include <cadef.h>


#ifndef vxWorks
    main(argc, argv)
    int     argc;		/* number of command line args */
    char   *argv[];		/* command line args */
    {
	arCFChanTest();
	exit(0);
    }
#endif
int
arCFChanTest()
{
    AR_CF_DESC *pCfDesc;	/* pointer to channel file descriptor */
    AR_CHAN_DESC *pChanStr;	/* pointer to channel descriptor for string */
    AR_CHAN_DESC *pChanShrt;	/* pointer to channel descriptor for short */
    AR_CHAN_DESC *pChanFlt;	/* pointer to channel descriptor for float */
    struct dbr_time_string str;	/* buffer for string value */
    struct dbr_sts_string strGR;/* buffer for string graphics info */
    struct dbr_time_string strR;/* buffer for reading string value */
    struct dbr_time_short shrt;	/* buffer for short value */
    struct dbr_gr_short shrtGR;	/* buffer for short graphics info */
    struct dbr_time_short shrtR;/* buffer for reading short value */
    struct dbr_time_float flt;	/* buffer for float value */
    struct dbr_gr_float fltGR;	/* buffer for float graphics info */
    struct dbr_time_float fltR;	/* buffer for reading float value */

    int		stat;		/* status return from calls */
    struct event_handler_args arg;

/*----------------------------------------------------------------------------
*    open the channel data file.  If it doesn't exist, create it
*---------------------------------------------------------------------------*/
    if ((pCfDesc = arCFOpen("accTest", O_RDWR)) == NULL) {
	if ((pCfDesc = arCFCreate("accTest", 50000)) == NULL) {
	    (void)printf("couldn't open accTest\n");
	    return ERROR;
	}
    }

/*----------------------------------------------------------------------------
*    fill in the buffers for the various types, open the channel, write the
*    buffer, and close the channel
*---------------------------------------------------------------------------*/
    str.status = 1;
    str.severity = 2;
    str.stamp.secPastEpoch = 123456;
    str.stamp.nsec = 789000000;
    strcpy(str.value, "65.43");
    if ((pChanStr = arCFChanOpen(pCfDesc, "string", O_RDWR)) == NULL) {
	(void)printf("error opening before write \"string\"\n");
    }
    else {
	if ((pChanStr->flags & AR_CDESC_NEW) != 0) {
	    arg.type = DBR_GR_STRING;
	    arg.count = 1;
	    arg.dbr = &strGR;
	    strGR.status = 0;
	    strGR.severity = 0;
	    if (arCFChanWriteGR(pChanStr, &arg) != OK) {
		(void)printf("error writing GR for \"string\"\n");
	    }
	}
	arg.type = DBR_TIME_STRING;
	arg.count = 1;
	arg.dbr = (void *)&str;

	if (arCFChanWrite(pChanStr, &arg) != OK) {
	    (void)printf("error writing for \"string\"\n");
	}
	if ((stat = arCFChanClose(&pChanStr)) != OK) {
	    (void)printf("error closing after write \"string\"\n");
	}
    }
    if ((pChanStr = arCFChanOpen(pCfDesc, "string", O_RDONLY)) == NULL) {
	(void)printf("error opening before read \"string\"\n");
    }
    else {
	if ((stat = arCFChanRead(pChanStr, DBR_TIME_STRING, &strR, 1)) != OK) {
	    (void)printf("error reading for \"string\"\n");
	}
	else {
	    if (
		    str.status != strR.status ||
		    str.severity != strR.severity ||
		    str.stamp.secPastEpoch != strR.stamp.secPastEpoch ||
		    str.stamp.nsec != strR.stamp.nsec ||
		    strcmp(str.value, strR.value) != 0) {
		(void)printf("read data wrong for \"string\"\n");
	    }
	}
	if ((stat = arCFChanClose(&pChanStr)) != OK) {
	    (void)printf("error closing after read \"string\"\n");
	}
    }

    shrt.status = 1;
    shrt.severity = 2;
    shrt.stamp.secPastEpoch = 123456;
    shrt.stamp.nsec = 789000000;
    shrt.value = 65;
    if ((pChanShrt = arCFChanOpen(pCfDesc, "short", O_RDWR)) == NULL) {
	(void)printf("error opening before write \"short\"\n");
    }
    else {
	if ((pChanShrt->flags & AR_CDESC_NEW) != 0) {
	    arg.type = DBR_GR_SHORT;
	    arg.count = 1;
	    arg.dbr = &shrtGR;
	    shrtGR.status = 0;
	    shrtGR.severity = 0;
	    (void)strcpy(shrtGR.units, "SHRT_U");
	    shrtGR.upper_disp_limit = 100;
	    shrtGR.lower_disp_limit = 0;
	    shrtGR.upper_alarm_limit = 100;
	    shrtGR.lower_alarm_limit = 0;
	    shrtGR.upper_warning_limit = 50;
	    shrtGR.lower_warning_limit = 10;
	    shrtGR.value = 15;
	    if (arCFChanWriteGR(pChanShrt, &arg) != OK) {
		(void)printf("error writing GR for \"short\"\n");
	    }
	}
	arg.type = DBR_TIME_SHORT;
	arg.count = 1;
	arg.dbr = (void *)&shrt;

	if (arCFChanWrite(pChanShrt, &arg) != OK) {
	    (void)printf("error writing for \"short\"\n");
	}
	if ((stat = arCFChanClose(&pChanShrt)) != OK) {
	    (void)printf("error closing after write \"short\"\n");
	}
    }
    if ((pChanShrt = arCFChanOpen(pCfDesc, "short", O_RDONLY)) == NULL) {
	(void)printf("error opening before read \"short\"\n");
    }
    else {
	if ((stat = arCFChanRead(pChanShrt, DBR_TIME_SHORT, &shrtR, 1)) != OK) {
	    (void)printf("error reading for \"short\"\n");
	}
	else {
	    if (
		    shrt.status != shrtR.status ||
		    shrt.severity != shrtR.severity ||
		    shrt.stamp.secPastEpoch != shrtR.stamp.secPastEpoch ||
		    shrt.stamp.nsec != shrtR.stamp.nsec ||
		    shrt.value != shrtR.value) {
		(void)printf("read data wrong for \"short\"\n");
	    }
	}
	if ((stat = arCFChanClose(&pChanShrt)) != OK) {
	    (void)printf("error closing after read \"short\"\n");
	}
    }

    flt.status = 1;
    flt.severity = 2;
    flt.stamp.secPastEpoch = 123456;
    flt.stamp.nsec = 789000000;
    flt.value = 65.43;
    if ((pChanFlt = arCFChanOpen(pCfDesc, "float", O_RDWR)) == NULL) {
	(void)printf("error opening before write \"float\"\n");
    }
    else {
	if ((pChanFlt->flags & AR_CDESC_NEW) != 0) {
	    arg.type = DBR_GR_FLOAT;
	    arg.count = 1;
	    arg.dbr = &fltGR;
	    fltGR.status = 0;
	    fltGR.severity = 0;
	    fltGR.precision = 3;
	    (void)strcpy(fltGR.units, "FLT_U");
	    fltGR.upper_disp_limit = 100.;
	    fltGR.lower_disp_limit = 0.;
	    fltGR.upper_alarm_limit = 100.;
	    fltGR.lower_alarm_limit = 0.;
	    fltGR.upper_warning_limit = 50.;
	    fltGR.lower_warning_limit = 10.;
	    fltGR.value = 15.;
	    if (arCFChanWriteGR(pChanFlt, &arg) != OK) {
		(void)printf("error writing GR for \"float\"\n");
	    }
	}
	arg.type = DBR_TIME_FLOAT;
	arg.count = 1;
	arg.dbr = (void *)&flt;

	if (arCFChanWrite(pChanFlt, &arg) != OK) {
	    (void)printf("error writing for \"float\"\n");
	}
	if ((stat = arCFChanClose(&pChanFlt)) != OK) {
	    (void)printf("error closing after write \"float\"\n");
	}
    }
    if ((pChanFlt = arCFChanOpen(pCfDesc, "float", O_RDONLY)) == NULL) {
	(void)printf("error opening before read \"float\"\n");
    }
    else {
	if ((stat = arCFChanRead(pChanFlt, DBR_TIME_FLOAT, &fltR, 1)) != OK) {
	    (void)printf("error reading for \"float\"\n");
	}
	else {
	    if (
		    flt.status != fltR.status ||
		    flt.severity != fltR.severity ||
		    flt.stamp.secPastEpoch != fltR.stamp.secPastEpoch ||
		    flt.stamp.nsec != fltR.stamp.nsec ||
		    flt.value != fltR.value) {
		(void)printf("read data wrong for \"float\"\n");
	    }
	}
	if ((stat = arCFChanClose(&pChanFlt)) != OK) {
	    (void)printf("error closing after read \"float\"\n");
	}
    }

/*----------------------------------------------------------------------------
*    re-open the channels, read the data, and verify that it's OK
*---------------------------------------------------------------------------*/

    (void)arCFClose(&pCfDesc);

    return OK;
}
