#ifndef INC_enumShared_h
#define INC_enumShared_h
/*	@(#)enumShared.h	1.1 8/24/92
 *	Author:	Roger A. Cole
 *	Date:	04-07-91
 *
 *	Copyright 1992, the Regents of the University of California.
 *
 *	This software was produced under U.S. Government contract:
 *	(W-7405-ENG-36) at the Los Alamos National Laboratory.
 *
 * Modification Log:
 * -----------------
 *  .01 04-07-92 rac	initial version
 * enumShared.h,v
 * Revision 1.3  1994/05/06 19:06:12  mrk
 * conversion from sccs to cvs
 *
 *
 *
 * make options
 *	-DvxWorks	makes a version for VxWorks
 *	-DNDEBUG	don't compile assert() checking
 *      -DDEBUG         compile various debug code, including checks on
 *                      malloc'd memory
 */
/*+/mod***********************************************************************
* TITLE	enumShared.h - definitions for XV_KEY_DATA enums
*
* DESCRIPTION
*	Contains XV_KEY_DATA definitions for the various modules in the
*	archiving directory.  This is done to allow sharing some of the
*	routines among the various programs.
*
*-***************************************************************************/

typedef enum {

		/* ARR */

    ARRCTX=100,		/* pointer to ARR context */
    CH_FUNC,		/* function for adding or deleting channel */
    ARR_pChan,		/* pointer to ARR_CHAN struct for a channel */

		/* AR */

    ARCTX,		/* pointer to AR context */
    ARCMD,		/* AR shell command string */
    ARREQ,		/* pointer to archive request */
    ARINFO,		/* type of information for status request */

		/* EX */

    EXCTX,		/* pointer to EX context */
    EXTYPE,		/* one of the EX_TYPE codes */

		/* PL */

    PLCTX,		/* pointer to PL context */
    PLTYPE,		/* one of the PL_TYPE codes */

		/* PR */

    PRCTX,		/* pointer to PR context */
    PRTYPE,		/* one of the PR_TYPE codes */

} XVKEYDATA;


/*-----------------------------------------------------------------------------
* client identifiers for use with the notifier (must start with 1)
*----------------------------------------------------------------------------*/
typedef enum {

			/* ARR */

    RETssfLsClient=10100,/* child process which lists `sample set' files */
    RETbcfLsClient,	/* child process which lists `by channel' files */
    lprClient,		/* child process which does a lpr command */
    RETcaClient,	/* timer func for Channel Access retrieval */
    CAClient,		/* Channel Access polling operations */

} ARR_NOTIFIER_CLIENT;


#endif	/* INC_enumShared_h */
